unit schTiposIVAClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_TiposIVA = '{D96E3FA9-3BEC-4A87-B5A6-F8A8AEF73D87}';

  { Data table names }
  nme_TiposIVA = 'TiposIVA';

  { TiposIVA fields }
  fld_TiposIVAID = 'ID';
  fld_TiposIVAREFERENCIA = 'REFERENCIA';
  fld_TiposIVADESCRIPCION = 'DESCRIPCION';
  fld_TiposIVAIVA = 'IVA';
  fld_TiposIVARE = 'RE';

  { TiposIVA field indexes }
  idx_TiposIVAID = 0;
  idx_TiposIVAREFERENCIA = 1;
  idx_TiposIVADESCRIPCION = 2;
  idx_TiposIVAIVA = 3;
  idx_TiposIVARE = 4;

type
  { ITiposIVA }
  ITiposIVA = interface(IDAStronglyTypedDataTable)
  ['{DEFBEA87-112C-4BFB-86E8-40085D5D6328}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property RE: Float read GetREValue write SetREValue;
  end;

  { TTiposIVADataTableRules }
  TTiposIVADataTableRules = class(TDADataTableRules, ITiposIVA)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property RE: Float read GetREValue write SetREValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TTiposIVADataTableRules }
constructor TTiposIVADataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TTiposIVADataTableRules.Destroy;
begin
  inherited;
end;

function TTiposIVADataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_TiposIVAID].AsInteger;
end;

procedure TTiposIVADataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_TiposIVAID].AsInteger := aValue;
end;

function TTiposIVADataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_TiposIVAREFERENCIA].AsString;
end;

procedure TTiposIVADataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_TiposIVAREFERENCIA].AsString := aValue;
end;

function TTiposIVADataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_TiposIVADESCRIPCION].AsString;
end;

procedure TTiposIVADataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_TiposIVADESCRIPCION].AsString := aValue;
end;

function TTiposIVADataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_TiposIVAIVA].AsFloat;
end;

procedure TTiposIVADataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_TiposIVAIVA].AsFloat := aValue;
end;

function TTiposIVADataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_TiposIVARE].AsFloat;
end;

procedure TTiposIVADataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_TiposIVARE].AsFloat := aValue;
end;


initialization
  RegisterDataTableRules(RID_TiposIVA, TTiposIVADataTableRules);

end.
